package	jp.co.sds_corp.syslog.layout;


/**
* フォーマット文字列を解析します。
*/
public class SyslogFormatParser extends FormatParser
{
	/**
	* 指定されたフォーマット文字列でFormatParserを作成します。
	* @param	fmt		フォーマット文字列
	*/
	public SyslogFormatParser( String fmt ) {
		super( fmt );
	}

	/**
	* 指定されたコンバータを生成します。
	* @param	c		コンバータを指定する文字
	* @return	コンバータ
	*/
	protected IConverter createConverter( char c ) {
		String opt;
		IConverter conv = null;
		switch ( c ) {
		case 'D':
			opt = getOption();
			conv = new SyslogConverter( SyslogConverter.Type.NOW, opt );
			break;
		case 'd':
			opt = getOption();
			conv = new SyslogConverter( SyslogConverter.Type.TIME, opt );
			break;
		case 'a':
			opt = getOption();
			conv = new SyslogConverter( SyslogConverter.Type.ADDRESS, opt );
			break;
		case 'h':
			opt = getOption();
			conv = new SyslogConverter( SyslogConverter.Type.HOSTNAME, opt );
			break;
		case 'F':
			opt = getOption();
			conv = new SyslogConverter( SyslogConverter.Type.FACILITY, opt );
			break;
		case 'f':
			opt = getOption();
			conv = new SyslogConverter( SyslogConverter.Type.FACILITY_MSG, opt );
			break;
		case 'P':
			opt = getOption();
			conv = new SyslogConverter( SyslogConverter.Type.PRIORITY, opt );
			break;
		case 'p':
			opt = getOption();
			conv = new SyslogConverter( SyslogConverter.Type.PRIORITY_MSG, opt );
			break;
		case 'm':
			opt = getOption();
			conv = new SyslogConverter( SyslogConverter.Type.MESSAGE, opt );
			break;
		case 'o':
			opt = getOption();
			conv = new SyslogConverter( SyslogConverter.Type.ORG_MESSAGE, opt );
			break;
		default:
			break;
		}
		return conv;
	}

}
